'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.__esModule = true;
exports.default = sortAndSerialize;

var _ramda = require('ramda');

var _isPlainObject = require('is-plain-object');

var _isPlainObject2 = _interopRequireDefault(_isPlainObject);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isSerializable(obj) {
  if (obj === undefined || obj === null || (0, _ramda.is)(Boolean, obj) || (0, _ramda.is)(Number, obj) || (0, _ramda.is)(String, obj)) {
    return true;
  }

  if (!(0, _isPlainObject2.default)(obj) && !(0, _ramda.is)(Array, obj)) {
    return false;
  }

  for (var key in obj) {
    if (!isSerializable(obj[key])) {
      return false;
    }
  }

  return true;
}

function sortObject(obj, strict) {
  if (obj instanceof Array) {
    var ary = undefined;
    if (strict) {
      ary = obj.sort();
    } else {
      ary = obj;
    }
    return ary;
  }

  if (obj && (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object') {
    var _ret = function () {
      if (!isSerializable(obj)) {
        return {
          v: { error: 'not serializable' }
        };
      }

      var tObj = {};
      Object.keys(obj).sort().forEach(function (key) {
        return tObj[key] = sortObject(obj[key]);
      });
      return {
        v: tObj
      };
    }();

    if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
  }

  return obj;
}

function sortAndSerialize(obj) {
  return JSON.stringify(sortObject(obj, true), undefined, 2);
}